Attribute VB_Name = "Routines"
'Compiled with VB v5
'must have Tools..Options..General..Error Trapping..'Break on Unhandled Errors' checked

Option Explicit
Dim box As Variant
Public Sub DoUpdate()
  Dim dummy As String, FlashWritten, SerialError As Boolean
  Dim ThisPort As Integer, retry As Integer
    
    Update.Comms.CommPort = 1
    
    On Error GoTo ErrorHandler
    
    Update.Show
    
    retry = 0
    ThisPort = 1
    Do
        statln ("")
        statln ("Trying to switch to com port " & ThisPort & "... ")
        retry = retry + 1
        FlashWritten = False
        SerialError = False
        
        Update.Comms.CommPort = ThisPort       'might jump to errorhandler here, changing SerialError = True
        If SerialError = False Then
            Update.status = "Searching for MACS on serial COM" & Update.Comms.CommPort & ":"
            If Update.Comms.PortOpen = False Then
                Update.Comms.PortOpen = True
            End If
            If SerialError = False Then
                If CheckForMacs = True Then
                    Update.status = "Found MACS on COM" & Update.Comms.CommPort & ": downloading program"
                    FlashWritten = WriteMacsFlash()
                    
                    If FlashWritten = False Then
                        Update.status = "Errors on MACS system, Super Ted!"
                    Else
                        Update.status = "MACS system updated to version 2"
                    End If
                End If
                'Update.Comms.PortOpen = False
             End If
        End If
        
        ThisPort = ThisPort + 1
    Loop Until ThisPort > 4 Or FlashWritten = True      'smt debug, should be >4
    
    If FlashWritten = False Then
        Update.status = "No MACS system found, Stupid Head!"
    End If
   
    GoTo OverErrorHandler
ErrorHandler:
    Select Case Err.Number
        Case 8002
            statln ("COM port " & ThisPort & " does not exist")
            Update.status = "COM port " & ThisPort & " does not exist"
            Delay (1)
            SerialError = True
            Resume Next
        Case 8005
            statln ("COM port " & ThisPort & " in use by another application")
            Update.status = "COM port " & ThisPort & " in use by another application"
            Delay (1)
            SerialError = True
            Resume Next
        Case 76
            box = MsgBox("Cannot find file", vbOKOnly, Err.Number)
            Delay (1)
            End
        Case Else
            box = MsgBox("Unknown Error ", vbOKOnly, Err.Number)
            Delay (1)
            SerialError = True
            Resume Next
    End Select
OverErrorHandler:

    'box = MsgBox("Finished!", vbOKOnly, "Error!")
    'End
End Sub
'returns true if macs found
Public Function CheckForMacs() As Boolean

    Dim dummy As String, pass As Boolean
    Dim retry As Integer
        
    'send out 'A', receive confirmation that MACS system is connected
    stat ("Finding MACS system ... sending ")
    pass = False
    retry = 0
    While ((pass = False) And (retry < 4))
        Delay (0.5)
        ClearSerialBuffer
        stat "'A' ... "
        Update.Comms.Output = ("A")              'check if macs connected
        Delay (0.02)                             'wait for it
        If Right(Update.Comms.Input, 1) = "a" Then
            statln (" received 'a', MACS system present")
            pass = True
        Else
            retry = retry + 1
        End If
    Wend
    Delay (0.03)
    
    If pass = False Then
        statln ("no response")
    End If
    
    CheckForMacs = pass                       'return pass/fail

End Function
Public Function WriteMacsFlash() As Boolean

    Dim CurrentLine, ByteStream As String
    Dim numBytes, i, CurrentPosition, High, Low, Address, Checksum As Integer
    Dim word As Double
    Dim tempAddress, entryPoint As Integer
    Dim TotalChecksum As Long
    Dim MACSUpdated As Boolean
    Dim SerialChar As String
    Dim timenow As Double
    Dim StartImage As Double
    Dim EntryImage As Double
    Dim LengthImage As Double
    Dim CheckSumImage As Double
    
        
    WriteMacsFlash = False  'initially it has errors, this may change later
    
    Address = &H7FFF        'for calculating stuff
    ByteStream = ""
    
    stat ("Decrypting .hex file ...")
    'open file
    Open "c:\working\andrew\macs\software\mnpicht\main.hex" For Input As #1 ' Open file for input.
    Input #1, CurrentLine  'read data into two variables.
    While Not EOF(1)       'loop until end of file.
        tempAddress = Hex2Dec(Mid(CurrentLine, 4, 4)) / 2
        If tempAddress = 0 Then
            entryPoint = Hex2Dec(Mid(CurrentLine, 10, 2) & Mid(CurrentLine, 18, 2))
        ElseIf Mid(CurrentLine, 9, 1) = "4" Then
            Input #1, CurrentLine   'Get next line
        ElseIf tempAddress < 512 Then
            'do nothing if address involves interrupt vectors
        ElseIf Mid(CurrentLine, 9, 1) = "1" Then
            Input #1, CurrentLine   'Ignore end of file line
        ElseIf Mid(CurrentLine, 9, 1) = "0" Then
            If tempAddress < Address Then
                'find start address
                Address = tempAddress
            End If
            numBytes = Hex2Dec(Mid(CurrentLine, 2, 2))
            Checksum = numBytes + Hex2Dec(Mid(CurrentLine, 4, 2)) + _
                Hex2Dec(Mid(CurrentLine, 6, 2))
            CurrentPosition = 10
            For i = 0 To (numBytes / 2) - 1
                Low = Hex2Dec(Mid(CurrentLine, CurrentPosition, 2))      'high byte of word
                High = Hex2Dec(Mid(CurrentLine, CurrentPosition + 2, 2))  'low byte of word
                ByteStream = ByteStream + Chr(High) + Chr(Low)
                Checksum = Checksum + High + Low
                CurrentPosition = CurrentPosition + 4               'advance pointer to next word
            Next i
            
            'verify bytes from checksum and 2's compliment
            Checksum = 255 - (Checksum Mod 256) + 1
            If Checksum = 256 Then Checksum = 0         'handles 255 to 0 wraparound for +1
            If Checksum <> Hex2Dec(Mid(CurrentLine, Len(CurrentLine) - 1, 2)) Then
                statln ("")
                statln ("Checksum error: calc checisum=" & Checksum & ", read chksum=" & _
                    Hex2Dec(Mid(CurrentLine, Len(CurrentLine) - 1, 2)))
                statln ("line is: " & Mid(CurrentLine, 1, Len(CurrentLine)))
            End If
        End If
        Input #1, CurrentLine  ' Read data into two variables.
    Wend
    Close #1    ' Close file.
    statln (" done")
    
    'send out 'F', then wait 20 secs for flash to be erased
    ClearSerialBuffer
    stat ("Erasing flash ... sending 'F' ...")
    ClearSerialBuffer
    Update.Comms.Output = "F"
    timenow = Timer
    Do
        DoEvents
    Loop Until Timer > (timenow + 20) Or Right(Update.Comms.Input, 1) = "f"
    If Timer < timenow + 19 Then
        statln (" received 'f', flash ram erased")
    Else
        statln ("ERROR: did not receive 'f', exiting")
'        End Sub
    End If
    
    stat ("Downloading header ... sending 'P' ...")
    Update.Comms.Output = "P"
    Delay (0.03)
    
    
    'send start address
    High = Int(Address / 256)
    Low = Address Mod 256
    StartImage = (High * &H100) + Low
    stat ("Sending start address (0x" & Hex(StartImage) & ") ...")
    If StartImage < &H1000 Then
        statln ("")
        statln ("***")
        stat (" WARNING: start address < 0x1000, program will be loaded into ")
        stat ("internal PIC17C43 EEPROM data space, must have ")
        statln ("linker options set properly, see mnpicht sample project for more details")
        statln ("***")
    Else
        statln (" done")
    End If
    Delay (0.03)
    Update.Comms.Output = Chr(High)
    Delay (0.03)
    Update.Comms.Output = Chr(Low)

    'send length of byte stream, in words
    High = Int(Len(ByteStream) / 2 / 256)
    Low = (Len(ByteStream) / 2) Mod 256
    LengthImage = (High * &H100) + Low
    stat ("Sending length (0x" & Hex(LengthImage) & ") ...")
    Delay (0.03)
    Update.Comms.Output = Chr(High)
    Delay (0.03)
    Update.Comms.Output = Chr(Low)
    statln (" done")
    
    'display calculated end of file
    statln ("Calculated ending point (0x" & Hex(StartImage + LengthImage) & ") ... done")
   
    'there is always the id byte 0xdea1 embedded before before the entry point
    Low = Asc(Mid(ByteStream, Len(ByteStream) - 2, 1))
    High = Asc(Mid(ByteStream, Len(ByteStream) - 3, 1))
    word = (High * 256) + Low
    stat ("Checking ID word (0x" & Hex(word) & ") ...")
    '56993 is 0xDEA1
    If word <> 56993 Then
        statln ("")
        statln ("***")
        stat ("WARNING: ID byte is not 0xDEA1, this indicates that the linker ")
        stat ("options have not been set properly, and the entry point for _main ")
        stat ("is probably wrong, must have linker options set properly")
        statln ("see mnpicht sample project for more details")
        statln ("***")
    Else
        statln (" match")
    End If

    'send entry point, address of main, this is taken from the last byte of the file
    'the this is purposely added to the compiled C file using linker options
    Low = Asc(Mid(ByteStream, Len(ByteStream), 1))
    High = Asc(Mid(ByteStream, Len(ByteStream) - 1, 1))
    EntryImage = (High * 256) + Low
    stat ("Sending entry point for _main (0x" & Hex(EntryImage) & ") ... ")
    Delay (0.03)
    Update.Comms.Output = Chr(High)
    Delay (0.03)
    Update.Comms.Output = Chr(Low)
    statln (" done")
    
    stat ("Downloading .hex data words ")
    'send bytestream
    TotalChecksum = 0
    For i = 1 To Len(ByteStream)
        'Delay (0.01)
        Update.Comms.Output = Mid(ByteStream, i, 1)
        TotalChecksum = TotalChecksum + Asc(Mid(ByteStream, i, 1))
        If (i Mod 10) = 0 Then
            stat (". ")
        End If
        If i Mod (Len(ByteStream) / 7) = 0 Then
            'only update bar if first time round, else we get oscillating progress bar
            'If Update.Bar.value <= 90 Then
                Update.progress.Caption = Format(Int(i / Len(ByteStream) * 90)) & "%"
                Update.Bar.value = i / Len(ByteStream) * Update.Bar.Max
                Update.Refresh
            'End If
        End If
    Next i
    statln (" done")

    'send checksum

    High = Int(TotalChecksum / 256) Mod 256 '255 inverts, the rest gets high/low byte
    Low = TotalChecksum Mod 256
    CheckSumImage = (High * &H100) + Low
    stat ("Sending checksum (0x" & Hex(CheckSumImage) & ") ...")
    Delay (0.03)
    Update.Comms.Output = Chr(High)
    Delay (0.03)
    Update.Comms.Output = Chr(Low)
    statln (" done")
    
    'receive confirmation
    stat ("Checking for good data transfer ...")
    Delay (0.01)
    SerialChar = Right(Update.Comms.Input, 1)
    If SerialChar = "1" Then
        WriteMacsFlash = True                   'we duns it good!
        statln (" received ascii '1', checksum is OK")
        statln ("System updated ... now PIC is executing downloaded code ...")
        statln ("")
    ElseIf SerialChar = "0" Then
        WriteMacsFlash = False                  'we dons it bad :-(
        statln (" received ascii '0', checksum indicated error")
        statln ("System NOT updated")
        statln ("")
    Else
        'they dons it bad :-)
        WriteMacsFlash = False
        statln (" received '" & SerialChar & "', the wrong confirmation of transfer.")
        statln ("System NOT updated")
        statln ("")
    End If
            
    'only update progress bar if its the first time round
    If WriteMacsFlash = True Then
        Update.progress.Caption = "100%"
        Update.Bar.value = Update.Bar.Max
        Delay (0.5)
    End If
    
End Function
Public Function Hex2Dec(value As String)

    Dim DecValue, count As Integer
    
    value = UCase(value)
    
    DecValue = 0
        
    For count = Len(value) To 1 Step -1
        If Asc(Mid(value, count, 1)) <= Asc("9") And Asc(Mid(value, count, 1)) >= Asc("0") Then
            DecValue = DecValue + (Asc(Mid(value, count, 1)) - Asc("0")) * (16 ^ (Len(value) - count))
        ElseIf Asc(Mid(value, count, 1)) <= Asc("F") And Asc(Mid(value, count, 1)) >= Asc("A") Then
            DecValue = DecValue + ((Asc(Mid(value, count, 1)) - Asc("A") + 10)) * (16 ^ (Len(value) - count))
        End If
    Next count
        
    Hex2Dec = DecValue
            
End Function

Public Sub Delay(PauseTime As Single)
    
    Dim start As Single
    
    start = Timer   ' Set start time
    Do While Timer < start + PauseTime
        DoEvents    ' Allow other processes to run
    Loop

End Sub
Public Sub ClearSerialBuffer()
Dim dummy As Variant
    dummy = Update.Comms.Input
End Sub
Public Sub stat(DebugMessage As String)
    Update.DebugTextBox.Text = Update.DebugTextBox.Text + DebugMessage
End Sub
Public Sub statln(DebugMessage As String)
    Update.DebugTextBox.Text = Update.DebugTextBox.Text + DebugMessage + vbCrLf
End Sub
Public Sub statln_clear()
    Update.DebugTextBox.Text = ""
End Sub

