//*******************
//function prototypes

void API_SelectFlashBank(unsigned char bank);
void API_SetupFlash(void);
void API_EraseFlash(void);
unsigned int readrom(unsigned int address);
#define API_ReadFlash readrom
unsigned int API_FlashDeviceID(void);
void API_EraseSector(unsigned int sector);
unsigned char API_WriteFlash(unsigned int addr, unsigned int data);
void API_ReadFlashArray(unsigned int rom_addr, unsigned int *ram_addr, unsigned char length);
unsigned char API_WriteFlashArray(unsigned int rom_addr, unsigned int *ram_addr, unsigned char length);
void API_TestRoutines(void);
#define TestRoutines API_TestRoutines

#define FLASH_A16	RB5

//boundary between PIC17C43 rom and external flash
#define	FLASH_MIN_ADDRESS 0x1000

//to check if flash ready, do two successive reads of any address
//	and check to see if any pins toggle, using XOR
#define flash_busy		(readrom(0xeeee) ^ readrom(0xeeee))

asm("WREG equ 0Ah");
asm("PCLATH equ 03h");
asm("PCL equ 02h");

// uses table write to put data on external address lines

#define writerom(writeaddress,writeinfo)					\
{																									\
	api_flash_rwrom_temp = writeinfo;								\
	TBLPTRH = (writeaddress >> 8);									\
	TBLPTRL = (writeaddress & 0xFF);								\
	WREG=(api_flash_rwrom_temp & 0xFF);							\
	asm("TLWT 0,WREG");															\
	WREG=(api_flash_rwrom_temp >> 8);								\
	asm("TABLWT 1,0,WREG");													\
}

//note that this stuffs up ram, as DelayUs(40) is used
#define reset_flash											\
	writerom(0xaaaa,0xf0f0);							\
	writerom(0xaaaa,0xf0f0);
	
#define API_ResetFlash() reset_flash

